function [nearestIdx, coordinates] = mykmeans(vectors, centroids)
% [nearestIndx, coordinates] = mykmeansMoje('cv05.data.txt',2);
% coordinates = vypise hodnoty konecnych souradnic
%
% KMeans algoritmus.
% vectors - instance/data, ktera se maji shlukovat. (Matice M x N - radky
% jednotlive vektory, sloupce dimenze)
% centroids - pocatecni nastaveni centroidu (Matice K x N)
% nearestIdx - vysledne prirazeni vektoru k jednotlivym centroidum
% coordinates - vysledne pozice centroidu (reprezentantu)

disp(centroids);    %vypise pocatecni hodnoty centroidu
numVec = size(vectors,1);

stopping = false;
iterationCount = 0; % K - pocet iteraci = kolikrat to projde pres ten while
while(~stopping)

    %Vypocet nejblizsiho reprezentanta
    nearestIdx = zeros(numVec, 1);
    for i = 1:numVec
        nearestIdx(i) = nearestCentroid(vectors(i,:), centroids);
    end

    %Presun centroidu (reprezentantu)
    %Tuto cast mate doplnit
    clusterCount = size(centroids, 1);  %pocet clusteru = veliksot pole, ktere jde do algoritmu
    arrClusterSize = zeros(clusterCount, 1);    % pole, do ktereho se uklada, kolik maji shluky prvku
                                                % na zacaku je tam 0 prvku
    % calculate number of instances in clusters
    
    for i = 1:numVec
        arrClusterSize(nearestIdx(i), 1) = arrClusterSize(nearestIdx(i), 1) + 1;
    % projde vsechny clustery
    end
    
    tempCentroids = zeros(clusterCount, size(vectors,2));
    
    for i = 1:clusterCount
        tempCentroids(i,:) = 1/arrClusterSize(i, 1)*sum(vectors(nearestIdx==i,:));
        % projde vsechny centroidy a podle vzorce z prednasky se udelaji nove lokace
        % tj. secte vsechny vektrory daneho shluku
        % nearestIndx==i - vytvori nulovy vektor, ktery neovlivni vysledek
        % je to pro pripad, ze vychazi index v poli 0
    end

    %Mam pokracovat?
    %Tuto cast mate doplnit
    iterationCount = iterationCount + 1;    % zvysi se pocet iteraci
    if (isequalwithequalnans(centroids,tempCentroids))
        % isequalwithequalnans = fce matlabu, ktera porovna matice
        % a predpoklada, ze NaN (= not a number) jsou stejne "hodnoty"
        % NaN vznikl, pokud v clusteru nebyl zadny prvek
        stopping = true;
    end
    
    centroids = tempCentroids;
end

coordinates = centroids;
fprintf('Number of iterations %d\n', iterationCount);
end


function nearestCentrIdx = nearestCentroid(instance, centroids)
%Vypocet eukleidovske vzdalenosti mezi jednim vektorem a vsemi centroidy
%(reprezentanty).
% instance - vektor
% centroids - centroidy
% Vraci index nejblizsiho centroidu

    numCentroids = size(centroids, 1);
    x = repmat(instance, numCentroids, 1);

    dist = x - centroids;
    dist = dist .* dist;

    dist = sqrt(sum(dist,2));

    [tmp, nearestCentrIdx] = min(dist);

end

